Open SCAP Library: CCE

Open SCAP Library

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Files | Data Structures | Functions
CCE

Common Configuration Enumeration. More...

## Files
file | cce.h

## Data Structures
struct | cce
| Structure holding CCE entries. More...
struct | cce_entry
| Structure holding single CCE entry data. More...
struct | cce_reference
| Structure holding a CCE reference. More...
struct | cce_reference_iterator
| Iterator over CCE references. More...
struct | cce_entry_iterator
| Iterator over CCE entries. More...

## Functions
struct cce * | cce::cce_new (const char *fname)
| Create a new CCE structure from XML file. More...
void | cce::cce_free (struct cce *cce)
| CCE structure destructor. More...

## Getters
Return value is pointer to structure's member. Do not free unless you null the pointer in the structure. Use remove function otherwise.
struct cce_entry_iterator * | cce::cce_get_entries (const struct cce *cce)
| Get an iterator to the contents of the CCE.
struct cce_entry * | cce::cce_get_entry (const struct cce *cce, const char *id)
| Get an CCE entry by ID. More...
const char * | cce_entry::cce_entry_get_id (const struct cce_entry *cce)
| Get CCE entry ID.
const char * | cce_entry::cce_entry_get_description (const struct cce_entry *cce)
| Get CCE entry desription.
struct oscap_string_iterator * | cce_entry::cce_entry_get_params (const struct cce_entry *cce)
| Get an iterator to CCE entry's parameters.
struct oscap_string_iterator * | cce_entry::cce_entry_get_tech_mechs (const struct cce_entry *cce)
| Get an iterator to CCE entry's technical mechanisms.
struct cce_reference_iterator * | cce_entry::cce_entry_get_references (const struct cce_entry *cce)
| Get an iterator to CCE entry's references.
const char * | cce_reference::cce_reference_get_source (const struct cce_reference *ref)
| Get source of CCE reference.
const char * | cce_reference::cce_reference_get_value (const struct cce_reference *ref)
| Get contents of CCE reference.

## Iterators
struct cce_reference * | cce_reference_iterator::cce_reference_iterator_next (struct cce_reference_iterator *it)
bool | cce_reference_iterator::cce_reference_iterator_has_more (struct cce_reference_iterator *it)
void | cce_reference_iterator::cce_reference_iterator_free (struct cce_reference_iterator *it)
void | cce_reference_iterator::cce_reference_iterator_reset (struct cce_reference_iterator *it)
struct cce_entry * | cce_entry_iterator::cce_entry_iterator_next (struct cce_entry_iterator *it)
bool | cce_entry_iterator::cce_entry_iterator_has_more (struct cce_entry_iterator *it)
void | cce_entry_iterator::cce_entry_iterator_free (struct cce_entry_iterator *it)
void | cce_entry_iterator::cce_entry_iterator_reset (struct cce_entry_iterator *it)

## Evaluators
bool | cce_validate (const char *filename)
| Vlaidate CCE XML file. More...
const char * | cce::cce_supported (void)
| Get supported version of CCE XML. More...

## Detailed Description

Common Configuration Enumeration.

Supported version: 5

## Function Documentation

void cce_entry_iterator_free | ( | struct cce_entry_iterator * | it | ) |

bool cce_entry_iterator_has_more | ( | struct cce_entry_iterator * | it | ) |

struct cce_entry * cce_entry_iterator_next | ( | struct cce_entry_iterator * | it | ) |
| read

void cce_entry_iterator_reset | ( | struct cce_entry_iterator * | it | ) |

void cce_free | ( | struct cce * | cce | ) |

CCE structure destructor.

Deinitializes CCE structure and releases used resources.

Parameters

  cce | pointer to target structure

struct cce_entry * cce_get_entry | ( | const struct cce * | cce,
|  | const char * | id
| ) |  |
| read

Get an CCE entry by ID.

Return values

  NULL | if given entry does not exist

struct cce * cce_new | ( | const char * | fname | ) |
| read

Create a new CCE structure from XML file.

Parameters

  fname | XML file name to porcess

Return values

  NULL | on failure

void cce_reference_iterator_free | ( | struct cce_reference_iterator * | it | ) |

bool cce_reference_iterator_has_more | ( | struct cce_reference_iterator * | it | ) |

struct cce_reference * cce_reference_iterator_next | ( | struct cce_reference_iterator * | it | ) |
| read

void cce_reference_iterator_reset | ( | struct cce_reference_iterator * | it | ) |

const char * cce_supported | ( | void |  | ) |

Get supported version of CCE XML.

Returns
  version of XML file format

bool cce_validate | ( | const char * | filename | ) |

Vlaidate CCE XML file.

Parameters

  filename | file to be validated

Returns
  result of validation (true / false)